<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: broadbandHandler.php,v 1.10 2002/04/26 00:52:55 pmartin Exp $

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

$oids = $cceClient->find("System");
$eth1 = $cceClient->find("Network", array("device" => "eth1"));
 
// eth1
$bootProtoMap = array("dhcp" => "dhcp", "pppoe" => "none", "static" => "none");

// turn off modem now, otherwise we lose control if pppoe is started and pppd is running
$cceClient->set($oids[0], "Modem", array("connMode" => "off"));
$errors = $cceClient->errors();

// set DHCP info, do this first in case needed by dhclient
$cceClient->set(
		$eth1[0], 
		"Dhclient", 
		array(
			"hostName" => $dhcpHostNameField, 
			"identifier" => $dhcpClientIdField
		)
	);
$errors = array_merge($errors, $cceClient->errors());

// set ip and netmask if in static mode
// we also set the gateway here as it needs the interface to be up to work.
if ($networkField == "static") {
	$cceClient->set(
			$eth1[0],
			"", 
			array(
				"ipaddr" => $ipAddressField, 
				"netmask" => $netMaskField,
	                        "enabled" => "1",
        	                "bootproto" => $bootProtoMap[$networkField]
			)
	);
	$errors = array_merge($errors, $cceClient->errors());
	$cceClient->set($oids[0], "", array("gateway" => $gatewayField));
} else if (count($errors) == 0) {
	// else just enable the interface
	if ($networkField != $oldBootproto) $cceClient->set($oids[0], "", array("gateway" => ""));
	$cceClient->set(
        	        $eth1[0],
			"",
                	array(
                        	"enabled" => "1",
                        	"bootproto" => $bootProtoMap[$networkField]
                	)
        	);
}
$errors = array_merge($errors, $cceClient->errors());


// IP forward and NAT
$cceClient->set($oids[0], "Network", array("internetMode" => "broadband", "ipForwarding" => 1, "nat" => $natField));
$errors = array_merge($errors, $cceClient->errors());

// set PPPoE info
$connModeMap = array("dhcp" => "off", "pppoe" => "on", "static" => "off");
$attributes = array("connMode" => $connModeMap[$networkField], "ethNumber" => 1, "userName" => $pppUserNameField);
// password can be blank for PPPoE
if($pppPasswordField != "")
  $attributes["password"] = $pppPasswordField;

$cceClient->set($oids[0], "Pppoe", $attributes);
$errors = array_merge($errors, $cceClient->errors());

print($serverScriptHelper->toHandlerHtml("/base/network/wan.php", $errors));

$serverScriptHelper->destructor();
?>
