<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: lanHandler.php,v 1.6 2000/09/18 06:05:40 ebraswell Exp $

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

$oids = $cceClient->find("System");

$cceClient->set($oids[0], "", array("gateway" => $gatewayField));
$errors = $cceClient->errors();

// find out IP forwarding and NAT inputs
$forward = ($forwardField != "forwardOff");
$nat = ($forwardField == "forwardNat");
$cceClient->set($oids[0], "Network", array("internetMode" => "lan", "ipForwarding" => $forward, "nat" => $nat));
$errors = array_merge($errors, $cceClient->errors());

if (empty($ipAddressField2) && empty($netMaskField2)) {	
	// if empty, turn eth1 off
	$cceClient->setObject(
			"Network",
			array("enabled" => "0"),
			"",
			array("device" => "eth1")
		);

} elseif ($ipAddressField2 && ($ipAddressField2 != $ipAddressOrig2 || $netMaskField2 != $netMaskOrig2)){
	// setup eth1 if they have entered anything new for ip or netmask
	$cceClient->setObject(
			"Network", 
			array(
				"ipaddr" => $ipAddressField2, 
				"netmask" => $netMaskField2, 
				"enabled" => "1", 
				"bootproto" => "none"
			), 
			"", 
			array("device" => "eth1")
		);
}

$eth1errors = $cceClient->errors();

// turn off PPPoE
$cceClient->set($oids[0], "Pppoe", array("connMode" => "off"));
$errors = array_merge($errors, $cceClient->errors());

// turn off modem
$cceClient->set($oids[0], "Modem", array("connMode" => "off"));
$errors = array_merge($errors, $cceClient->errors());

if( count($eth1errors) == 0 && $SERVER_ADDR == $ipAddressOrig2 and $ipAddressOrig2 != $ipAddressField2 ){	//If IP is different and admin used this IP, redirect to new one
	?>
	<SCRIPT LANGUAGE="Javascript">
	<!--
		setTimeout("parent.location = 'http://<? echo $ipAddressField2; ?>/login'", 200);
	//-->
	</SCRIPT>
	<?
} else {
	print($serverScriptHelper->toHandlerHtml("/base/network/wan.php", array_merge($eth1errors, $errors)));
}




$serverScriptHelper->destructor();
?>
