<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: modemHandler.php,v 1.9 2002/04/26 00:52:55 pmartin Exp $

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

$oids = $cceClient->find("System");

$ip = ($modemIpField == "") ? "0.0.0.0" : $modemIpField;

// create array of values to pass to set
// need to do this so password field can be optional
// "authMode" => $modemAuthModeField,
$settings = array(
	"connMode" => $modemConnModeField,
	"serverName" => $modemAuthHostField,
	"phone" => $modemPhoneField,
	"userName" => $modemUserNameField,
	"initStr" => $modemInitStrField,
	"localIp" => $ip,
	"speed" => $modemSpeedField,
	"pulse" => $modemPulseField,
	"dialhours" => $dialoutWindowing
);

// $memberSelector = $factory->getSetSelector("dialoutWindowing", $dialtimesString,
//   $nodialtimesString, "dialTimes", "noDialTimes");

error_log("phone $modemPhoneField");

if ($modemPasswordField)
	$settings["password"] = $modemPasswordField;

$cceClient->set($oids[0], "Modem", $settings);
$errors = $cceClient->errors();

// get rid of default gateway because, if the modem is our internet connection
// it needs to setup a default gateway through the ppp interface to get packets out
$cceClient->set($oids[0], "", array( "gateway" => "" ));
$errors = array_merge($errors, $cceClient->errors());

// IP forwarding and NAT
$cceClient->set($oids[0], "Network", array("internetMode" => "narrowband", "ipForwarding" => 1, "nat" => $natField));
$errors = array_merge($errors, $cceClient->errors());

// turn off DHCP
$cceClient->setObject("Network", array("bootproto" => "none"), "", array("device" => "eth1"));
$errors = array_merge($errors, $cceClient->errors());

// turn off PPPoE
$cceClient->set($oids[0], "Pppoe", array("connMode" => "off"));
$errors = array_merge($errors, $cceClient->errors());

if ((count($errors) == 0) && $test)
	print($serverScriptHelper->toHandlerHtml("/base/modem/modemTest.php"));
else
	print($serverScriptHelper->toHandlerHtml("/base/network/wan.php", $errors));

$serverScriptHelper->destructor();
?>
