<?

// Author: Tim Hockin
// Copyright 2000, Cobalt Networks.  All rights reserved.
// Use this to create a generic details page:
//   declare the variables 'name' (namespace) and 'title' (i18n tag or str), 
//   then just include this file.

include("ServerScriptHelper.php");
include("base/am/am_detail.inc");

$serverScriptHelper = new ServerScriptHelper();
$cce = $serverScriptHelper->getCceClient();
$factory = $serverScriptHelper->getHtmlComponentFactory("base-network");
$page = $factory->getPage();
$i18n = $factory->i18n;

print($page->toHeaderHtml());

am_detail_block($factory, $cce, 'Network', '[[base-network.amNetDetails]]');

$page = $factory->getPage();
$i18n = $factory->i18n;

$list = $factory->getScrollList("amNetStats", array('', 'eth0', 'eth1'));
$list->setEntryCountHidden(true);
// FIXME make column widths match the paged block
$list->setColumnWidths(array('40%', '30%', '30%'));

$eth0_obj = $cce->getObject('Network', array('device' => 'eth0'));
$eth1_obj = $cce->getObject('Network', array('device' => 'eth1'));
						   
// Get eth0 info
if ($eth0_obj['enabled']) {
  $eth0 = `grep eth0 /proc/net/dev`;
  $eth0 = chop(ltrim($eth0));
  $eth0 = split("[^[:alnum:]]+", $eth0);
  $eth0['recv_bytes'] = $eth0[1];
  $eth0['recv_packets'] = $eth0[2];
  $eth0['sent_bytes'] = $eth0[9];
  $eth0['sent_packets'] = $eth0[10];
  $eth0['errors'] = $eth0[3] + $eth0[11];
  $eth0['collisions'] = $eth0[14];
} else {
  $eth0['recv_bytes'] = $eth0['recv_packets'] = $eth0['sent_bytes']  =
    $eth0['sent_packets'] = $eth0['errors'] = $eth0['collisions'] = $i18n->interpolate('stats_disabled');
}

// Get eth1 info
if ($eth1_obj['enabled']) {
  $eth1 = `grep eth1 /proc/net/dev`;
  $eth1 = chop(ltrim($eth1));
  $eth1 = split("[^[:alnum:]]+", $eth1);
  $eth1['recv_bytes'] = $eth1[1];
  $eth1['recv_packets'] = $eth1[2];
  $eth1['sent_bytes'] = $eth1[9];
  $eth1['sent_packets'] = $eth1[10];
  $eth1['errors'] = $eth1[3] + $eth1[11];
  $eth1['collisions'] = $eth1[14];
} else {
  $eth1['recv_bytes'] = $eth1['recv_packets'] = $eth1['sent_bytes']  =
    $eth1['sent_packets'] = $eth1['errors'] = $eth1['collisions'] = $i18n->get('stats_disabled');
}  

$stylist = $serverScriptHelper->getStylist();
$style = $stylist->getStyle("PagedBlock");

$props = array('recv_bytes', 'recv_packets', 
	       'sent_bytes', 'sent_packets',
	       'errors', 'collisions');

// add statistics to scroll list
// need to set the style for each header so that
// it shows up in the "Label" color
foreach ($props as $prop) {
  $label = $factory->getLabel($prop);
  $label->setStyleTarget("labelLabel");
  $label->setStyle($style);
  $list->addEntry( array(
	 $label,
	 $factory->getTextField($prop, $eth0[$prop], "r"),   // eth0
	 $factory->getTextField($prop, $eth1[$prop], "r"))); // eth1
}

print '<BR>';
print ($list->toHtml());

am_back($factory);

print($page->toFooterHtml());

$serverScriptHelper->destructor();

?>
