<?php
// Author: Kevin K.M. Chiu
// Copyright 2000, Cobalt Networks.  All rights reserved.
// $Id: wanNoneHandler.php,v 1.7 2002/03/27 22:53:49 pmartin Exp $

include("ServerScriptHelper.php");

$serverScriptHelper = new ServerScriptHelper();
$cceClient = $serverScriptHelper->getCceClient();

// turn off IP forwarding
$cceClient->setObject("System", array("internetMode" => "none", "ipForwarding" => 0), "Network");
$errors = $cceClient->errors();

// should also blank out default gateway because otherwise what we are doing is slightly misleading
$cceClient->setObject("System", array("gateway" => ""));
$errors = array_merge($errors, $cceClient->errors());

// turn off DHCP and disable eth1 if we were dhcping, to avoid us using an ip that the dhcp server
// may give out to someone else after we don't renew our lease after timing out
//$eth1 = $cceClient->getObject("Network", array("device" => "eth1"));
//$pppoe = $cceClient->getObject("System", array(), "Pppoe");

//if ($eth1["bootproto"] == "dhcp" || $pppoe["connMode"] != "off") {
	$cceClient->setObject(
			"Network", 
			array(
				"enabled" => "0", 
				"bootproto" => "none"
			), 
			"", 
			array("device" => "eth1")
		);
	$errors = array_merge($errors, $cceClient->errors());
//}

// turn off PPPoE
$cceClient->setObject("System", array("connMode" => "off"), "Pppoe");
$errors = array_merge($errors, $cceClient->errors());

// turn off modem
$cceClient->set($oids[0], "Modem", array("connMode" => "off"));
$errors = array_merge($errors, $cceClient->errors());

print($serverScriptHelper->toHandlerHtml("/base/network/wan.php?isFixed=true", $errors));

$serverScriptHelper->destructor();
?>
